--- u-boot-2011.06_original/common/cmd_update.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_update.c	2015-06-18 16:19:05.254106000 +0800
@@ -0,0 +1,1322 @@
+#include "cnc_util.h"
+#include <net.h>
+
+//"update force splash,kernel,rootfs tftp://192.168.300.100/zcnc83xxS.bin";
+//"update force splash,kernel,rootfs usb://zcnc83xxS.bin";
+//"update miniloader,uboot  usb://zcnc83xxS.bin";
+//"update force";
+
+/* Update command usage - 
+ * update [CSV_LIST_OF_MTD_PARTITION_NAME] [force] [filename-url]
+ *
+ * e.g.:
+ * 
+ * 1) update                                                 -  update all partion available in cnc83xxS.bin from USB drive (except miniloader and uboot) you can only upgrade, if newer version is not greater
+ *                                                              compare to current working one, it will be skipped. (upgrade only)
+ * 2) update force                                           -  update all partion available in cnc83xxS.bin from USB drive - ignore version checking so user can do downgrade, upgrade.
+ * 3) update uboot,miniloader                                -  update uboot and miniloader if it is available in cnc83xxS.bin from USB drive (upgrade only)
+ * 4) update miniloader                                      -  update miniloader if it is available in cnc83xxS.bin from USB drive - (upgrade only)
+ * 5) update splash,kernel,jffs2                             -  update splash, kernel and jffs2 - if it is available in cnc83xxS.bin from USB drive - (upgrade only)
+ * 6) update force splash,kernel,jffs2 usb://cnc83xxS.bin    -  update splash, kernel and jffs2 - if it is available in MyCnc83xxS.bin from USB drive and ignore version checking
+
+ * 7) update tftp://192.168.1.2                              -  update all partion available in cnc83xxS.bin from tftp server (except miniloader and uboot) you can only upgrade, if newer version is not greater
+ *                                                              compare to current working one, it will be skipped. (upgrade only)
+ * 8) update force tftp://192.168.1.2                        -  update all partion available in cnc83xxS.bin from tftp server - ignore version checking so user can do downgrade, upgrade.
+ * 9) update uboot,miniloader tftp://192.168.1.2             -  update uboot and miniloader if it is available in cnc83xxS.bin from tftp server (upgrade only)
+ * 10) update miniloader tftp://192.168.1.2                  -  update miniloader if it is available in cnc83xxS.bin from tftp server - (upgrade only)
+ * 11) update splash,kernel,jffs2 tftp://192.168.1.2         -  update splash, kernel and jffs2 - if it is available in cnc83xxS.bin from tftp server - (upgrade only)
+ * 12) update force splash,kernel,jffs2 tftp://192.168.1.2/cnc83xxS.bin  -  update splash, kernel and jffs2 - if it is available in imaeg from tftp server - file name is MyCnc83xxS.bin and ignore version checking
+ * 
+ * 13) update help                                           -  help, usage, print valid aprtition name availale in bootargs.
+ */
+
+#if defined(CONFIG_AUTO_UPDATE) && defined(CONFIG_USB_STORAGE)
+
+int gpio_num_for_blink = -1;
+int rate_in_ms = -1;
+extern void disable_and_unregister_wd_timer_irq(void);
+extern void register_and_enable_wd_timer_irq(unsigned int rate_in_ms);
+
+//#define DEBUG_UPDATE
+#ifdef	DEBUG_UPDATE
+#define debug_update(fmt,args...)	printf (fmt ,##args)
+#else
+#define debug_update(fmt,args...)
+#endif	/* DEBUG_UPDATE */
+
+//---------------------------------------------------------------------------------------------------------------------------------------------------
+
+//#undef debug
+//#define debug printf
+
+#define member_size(type, member) sizeof(((type *)0)->member)
+
+#define FILE_VERSION        (0x00000100)
+#define SIGNATURE           (0x00001900)
+#define DEFAULT_CNC83XX_FILE_NAME ("cnc83xx.bin")
+#define DEFAULT_CNC83XXU_FILE_NAME ("cnc83xxU.bin")
+#define member_size(type, member) sizeof(((type *)0)->member)
+#define DEFAULT_VENDOR_ID   (0xCA000000)
+#define DEFAULT_PRODUCT_ID  (0x19000000)
+
+#define DDR_LOAD_ADDRESS    0x10000000
+
+
+#undef PAGE_SIZE
+#undef MTD_WRITEABLE
+
+
+#define PAGE_SIZE           (4*1024)
+#define MTD_WRITEABLE		(0x40)
+#define MTD_POWERUP_LOCK	(0x80)
+#define UINT_MAX            0xffffffff    /* maximum unsigned int value */
+
+#define VERSION_NO_LENGTH     256
+#define NVRAM_PARAM_TEXT_SIZE 4096 /* 4K */
+
+
+#define  UPDATE_MAX_PARTITION_SUPPORT   10 
+
+const char* ImageTypeByName[] = {
+	"KERNEL",
+	"RAMDISK",
+	"JFFS2",
+	"RAW"
+};
+
+const char* SkipParitionCheckingForUpgrade[]=
+{
+	"env",
+	"logo",
+	"update",
+	"user",
+	"free",
+
+	"miniloader",
+	"env_f",
+	"env1",
+	"rootfs_info_f",
+	"env2",
+	"rootfs_info",
+	"uboot1",
+	"uboot2",
+	"rootfs1",
+	"rootfs2",
+	"blob",
+	"kernel",
+	"logo",
+	"datafs",
+	"jffs2",
+	"conf",
+	NULL
+};
+
+typedef struct UpdateObject_t
+{
+	char   			mMtdId[16];
+	char   			mPartitionName[16];
+	UInt32 			mPartitionPositionInFlash;
+	UInt32          mImagePositionInFile;
+	UInt32 			mImageLength;
+	UInt32 			mPartitionSizeInFlash; 
+	UInt32       	mExtraInfo;
+}UpdateObject_t;
+
+typedef struct UpdateCommandObject_t
+{
+	int  mForce;
+	int  mUsb; //0-tftp, 1-usb, 2-mmc0, 3-mmc1
+	char mFileName[256];
+	char mIpAddress[15+1];
+	int  mNoOfValidParition;
+	UpdateObject_t mUpdateObjectList[MAXIUM_NO_OF_IMAGE];
+}UpdateCommandObject_t;
+
+typedef struct UpdateCommandParameterListObject_t
+{
+#define MAX_ARG_COUNT 5
+	int mNoOfParameter;
+	char mParameterList[MAX_ARG_COUNT][256];
+}UpdateCommandParameterListObject_t;
+
+typedef int (*Ptr2FuncParameter)(char* pBuf , UpdateCommandParameterListObject_t * apObject);
+typedef int (*Ptr2FuncPartition)(char* pBuf , UpdateCommandObject_t * apObject);
+
+//--------------------------------------------------------------------------------------------
+
+static int LookForUnsignedImage=0;
+
+//--------------------------------------------------------------------------------------------
+#pragma pack(1)
+typedef struct Header2_t
+{
+	UInt32 mValid;
+	char   mMtdId[16];
+	char   mPartitionName[64];
+	char   mVersionNo[256];
+	UInt32 mExtraInfo;					//d0 - 0 = encrypted (default)   , 1 = unencrypted
+	//d1 - 0 = nand (default)        , 1 = spi
+	//d2 - 0 = erase & write(default), 1 = preserved old content
+	UInt32 mImageLength;
+	UInt32 mImagePositionInFile;
+	UInt32 mPartitionSizeInFlash; 
+	UInt32 mPartitionPositionInFlash;
+}Header2_t;
+
+#pragma pack(1)
+typedef struct Header1_t
+{
+	int  mSignature;
+	int  mFileFormatVersionNo;
+	int  mVendorId;
+	int  mProductId;
+	char mCustomerName[32];
+	char mBootCmd[512];
+	char mBootArgs[512];
+	char mNvRamParamText[ NVRAM_PARAM_TEXT_SIZE];
+	int  mNoOfValidParition;
+	Header2_t mImageList[MAXIUM_NO_OF_IMAGE];		//images can be stored
+	UInt32 mHeaderCrc;
+	char mRsaSignature[256];
+}Header1_t;
+//--------------------------------------------------------------------------------------------
+extern int cnc_NorErase(UInt32 aFlashStartAddress, UInt32 aLength);
+extern int cnc_NorVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+extern int cnc_NorRead(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+extern int cnc_NorWrite(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+
+
+/* externals */
+extern int fat_register_device(block_dev_desc_t *, int);
+extern int file_fat_detectfs(void);
+extern long file_fat_read(const char *, void *, unsigned long);
+//extern int i2c_read (unsigned char, unsigned int, int , unsigned char* , int);
+extern int flash_sect_erase(ulong, ulong);
+extern int flash_sect_protect (int, ulong, ulong);
+extern int flash_write (char *, ulong, ulong);
+/* change char* to void* to shutup the compiler */
+extern block_dev_desc_t *get_dev (const char*, int);
+
+extern int GetSizeAndOffset(const char* pBuf, int* apSize, int *apOffset);
+extern int GenerateImagePartitionListFromBootArgs(const char* apBootArgs, ImagePartitionList_t *apImagePartitionList);
+
+
+/*
+ * The format for the command line is as follows:
+ *
+ * mtdparts=<mtddef>[;<mtddef]
+ * <mtddef>  := <mtd-id>:<partdef>[,<partdef>]
+ *              where <mtd-id> is the name from the "cat /proc/mtd" command
+ * <partdef> := <size>[@offset][<name>][ro][lk]
+ * <mtd-id>  := unique name used in mapping driver/device (mtd->name)
+ * <size>    := standard linux memsize OR "-" to denote all remaining space
+ * <name>    := '(' NAME ')'
+ *
+ * Examples:
+ *
+ * 1 NOR Flash, with 1 single writable partition:
+ * edb7312-nor:-
+ *
+ * 1 NOR Flash with 2 partitions, 1 NAND with one
+ * edb7312-nor:256k(ARMboot)ro,-(root);edb7312-nand:-(home)
+ */
+
+int SearchStringInAList(const char* pBuffer, const char* aList[])
+{
+	int i;
+	char* p1;
+	i=0;
+
+	while ( aList[i] != NULL)
+	{		
+		p1 = strstr(pBuffer, aList[i] );
+		if ( NULL !=  p1 )
+		{
+			return 0;
+		}		
+		i++;
+	}
+
+	return -1;
+}
+
+int VerifyAllPartitionPresentInImage(const Header1_t * apHeader1 , const ImagePartitionList_t *apImagePartitionList)
+{
+	int Status = 0;
+
+	int i=0;
+	int j=0;
+	char * p1;
+	int found=-1;
+
+	for(i=0; i < apImagePartitionList->mNoOfPartition ; i++)
+	{
+		p1 = (char*) (apImagePartitionList->mImagePartitionList[i].mPartionName );
+		found = -1;
+		printf("Searching for %s partition in supplied imaged...", p1);
+		if ( 0 == SearchStringInAList((const char*) p1, SkipParitionCheckingForUpgrade) )
+		{
+			printf("Skipping %s paritition\n", p1);
+			continue;
+		}
+
+		for ( j=0; j < apHeader1->mNoOfValidParition ; j++)
+		{
+			if ( 0 == strcmp ( apHeader1->mImageList[j].mPartitionName , p1 ) )
+			{
+				printf(" found it, %sPASS\n%s",  ColorGreen , ColorNormal );
+				found =1;
+				break;
+			}
+		}
+
+		if ( -1 == found)
+		{
+			printf(" not found, %sFAIL\n%s", ColorRed, ColorNormal );
+			return -1;
+		}
+	}
+	return Status;	
+}
+
+int isspace(int c) 
+{
+	/* first check gives quick exit in most cases */
+	return(c<=' ' && (c==' ' || (c<=13 && c>=9)));
+}
+
+static int CSV_Callback(char* pBuf, UpdateCommandObject_t * apObject)
+{
+	printf("Partition(%d) - %s\n", apObject->mNoOfValidParition , pBuf);
+	if (apObject->mNoOfValidParition < MAXIUM_NO_OF_IMAGE )
+	{
+		strncpy( apObject->mUpdateObjectList[apObject->mNoOfValidParition].mPartitionName, 
+				pBuf, 
+				sizeof (apObject->mUpdateObjectList[apObject->mNoOfValidParition].mPartitionName)
+			   );
+		apObject->mNoOfValidParition++;   
+	}
+	else
+	{
+		printf("ERROR: Parameter list overflow\n");
+		return -1;
+	}
+	return 0;
+}
+
+static int SSV_Callback(char*pBuf , UpdateCommandParameterListObject_t * apObject)
+{
+	printf("Parameter(%d) - %s\n", apObject->mNoOfParameter, pBuf);
+	if (apObject->mNoOfParameter < MAX_ARG_COUNT )
+	{
+		strncpy ( apObject->mParameterList[apObject->mNoOfParameter] , pBuf , sizeof(apObject->mParameterList[0]) );
+		apObject->mNoOfParameter++;    
+	}
+	else
+	{
+		printf("ERROR: Parameter list overflow\n");
+		return -1;
+	}
+	return 0;
+}
+
+static int trim(char** pStr)
+{
+	char *end;
+	char* str = *pStr;
+	while( isspace(*str)) 
+	{
+		(*pStr)++;
+		str++;
+	}
+
+	if(*str == 0) 
+	{
+		return 0;
+	}
+
+	end = str + strlen(str) - 1;
+	while(end > str && isspace(*end))
+	{
+		end--;
+	}
+	*(end+1) = 0;
+	return 0;
+}
+
+static void CSV(const char* str, UpdateCommandObject_t * apObject , Ptr2FuncPartition  pPtr2Func )
+{	
+	const char s[] = ",";
+	char *token;
+
+	token = strtok((char*) str, s);
+
+	while( token != NULL ) 
+	{
+		trim( & token);
+		if ( NULL != pPtr2Func  )
+		{
+			pPtr2Func(token , apObject);
+		}
+		token = strtok(NULL, s);
+	}   
+}
+
+static void SSV(const char* str, UpdateCommandParameterListObject_t * apObject , Ptr2FuncParameter  pPtr2Func )
+{	
+	const char s[] = " ";
+	char *token;
+
+	token = strtok((char*) str, s);
+
+	while( token != NULL ) 
+	{
+		trim( & token);   
+		if ( NULL != pPtr2Func  )
+		{
+			pPtr2Func(token , apObject);
+		}
+		token = strtok(NULL, s);
+	}   
+}
+
+static int ParseUpdateCommand(const char* apBuffer, UpdateCommandParameterListObject_t * apParameterObj,  UpdateCommandObject_t * apUpdateCommandObject )
+{
+	char* TempP2=NULL;
+	char* TempP3;
+	char* TempP4;
+	char* TempP5;
+	char* TempP6;
+	char TempBuf2[256]={0};
+
+	int i;
+	TempP2=TempP2;
+
+	if ( 0 == LookForUnsignedImage ){
+		strncpy(apUpdateCommandObject->mFileName, DEFAULT_CNC83XX_FILE_NAME , sizeof (apUpdateCommandObject->mFileName));
+	}
+	else{
+		strncpy(apUpdateCommandObject->mFileName, DEFAULT_CNC83XXU_FILE_NAME , sizeof (apUpdateCommandObject->mFileName));
+	}
+
+	strncpy(TempBuf2, apBuffer, sizeof(TempBuf2) );
+
+	//get all param first
+	SSV(TempBuf2, apParameterObj, SSV_Callback);
+	printf("%s\n", TempBuf2);
+	//get parition names.
+	for(i=0 ; i < MAX_ARG_COUNT ; i++){
+		TempP2 = strstr( apParameterObj->mParameterList[i] , ",");
+		TempP3 = strstr( apParameterObj->mParameterList[i] , "usb://");
+		TempP4 = strstr( apParameterObj->mParameterList[i] , "tftp://");
+		TempP5 = strstr( apParameterObj->mParameterList[i] , "mmc0://");
+		TempP6 = strstr( apParameterObj->mParameterList[i] , "mmc1://");
+
+
+		if ( 0 == strcmp(apParameterObj->mParameterList[i], "update" ) ){
+			continue;
+		}
+		if ( 0 == strcmp(apParameterObj->mParameterList[i], "force" ) ){
+			apUpdateCommandObject->mForce=1;
+			continue;
+		}
+		if ( 0 == strcmp(apParameterObj->mParameterList[i], "blink" ) ){
+			printf("blink case\n");
+			gpio_num_for_blink = simple_strtoul(apParameterObj->mParameterList[2], NULL, 0);
+			rate_in_ms = simple_strtoul(apParameterObj->mParameterList[3], NULL, 0);
+			printf("gpio_num_for_blink = %d, rate_in_ms = %d\n",gpio_num_for_blink,rate_in_ms);
+			continue;
+		}
+		if ( NULL != TempP3 ){
+			//mUsb - file name
+			apUpdateCommandObject->mUsb=1;
+			strncpy(apUpdateCommandObject->mFileName , TempP3 + strlen("usb://") , sizeof(apUpdateCommandObject->mFileName) );
+			continue;
+		}
+		if ( NULL != TempP5 ){
+			//mUsb - file name
+			apUpdateCommandObject->mUsb=2;
+			strncpy(apUpdateCommandObject->mFileName , TempP3 + strlen("mmc0://") , sizeof(apUpdateCommandObject->mFileName) );
+			continue;
+		}
+		if ( NULL != TempP6 ){
+			//mUsb - file name
+			apUpdateCommandObject->mUsb=3;
+			strncpy(apUpdateCommandObject->mFileName , TempP3 + strlen("mmc1://") , sizeof(apUpdateCommandObject->mFileName) );
+			continue;
+		}
+		if ( NULL != TempP4 ){
+			//tftp - file name
+			apUpdateCommandObject->mUsb=0;
+			TempP4 = TempP4 + strlen("tftp://");
+			TempP3 = strstr(TempP4, "/" );
+			if (TempP3 == NULL ){
+				strncpy(apUpdateCommandObject->mFileName , TempP4 , sizeof(apUpdateCommandObject->mFileName) );
+			}
+			else{
+				strncpy(apUpdateCommandObject->mFileName , TempP3+1 , sizeof(apUpdateCommandObject->mFileName) );
+				strncpy(apUpdateCommandObject->mIpAddress , TempP4 , TempP3-TempP4 );
+			}	
+			continue;
+		}
+		//else may be partition...
+		if((-1 == gpio_num_for_blink) && (-1 == rate_in_ms))
+			CSV(apParameterObj->mParameterList[i], apUpdateCommandObject , CSV_Callback);
+	}
+	return 0;
+}
+
+
+
+int UsbStart(void)
+{
+	block_dev_desc_t *stor_dev;
+	int au_usb_stor_curr_dev = -1;
+	/* start USB */
+	if (usb_stop() < 0)
+	{
+		printf ("usb_stop failed\n");
+		return -1;
+	}
+	if (usb_init() < 0)
+	{
+		printf ("usb_init failed\n");
+		return -1;
+	}
+
+	/*
+	 * check whether a storage device is attached (assume that it's
+	 * a USB memory stick, since nothing else should be attached).
+	 */
+	au_usb_stor_curr_dev = usb_stor_scan(1);
+	if (au_usb_stor_curr_dev == -1)
+	{
+		printf ("No device found. Not initialized?\n");
+		return -1;
+	}
+
+	/* check whether it has a partition table */
+	stor_dev = get_dev("usb", 0);
+	if (stor_dev == NULL)
+	{
+		printf ("uknown device type\n");
+		return -1;
+	}
+
+	int partition_index = 1 ;
+	int partition_available = 0 ;
+	for(;partition_index <= UPDATE_MAX_PARTITION_SUPPORT ; partition_index++  )
+	{	
+		if (fat_register_device(stor_dev, partition_index) == 0)
+		{
+			partition_available = 1 ;	
+			//		stor_dev->dev = partition_index ;
+			printf ("USB %d:%d is availble for fatls\n", au_usb_stor_curr_dev, partition_index);
+			break;
+		}
+		else
+		{	
+			printf ("Unable to use USB %d:%d for fatls\n", au_usb_stor_curr_dev, partition_index);
+		}	
+	}
+
+	if(partition_available == 0)
+		return -1 ;
+
+	if (file_fat_detectfs() != 0)
+	{
+		printf ("file_fat_detectfs failed\n");
+		return -1;
+	}
+
+	return 0;
+}
+
+int MMCStart(int index)
+{
+	block_dev_desc_t *stor_dev;
+
+	/* check whether it has a partition table */
+	stor_dev = get_dev("mmc", index);
+	if (stor_dev == NULL)
+	{
+		printf ("uknown device type\n");
+		return -1;
+	}
+
+	int partition_index = 1 ;
+	int partition_available = 0 ;
+	for(;partition_index <= UPDATE_MAX_PARTITION_SUPPORT ; partition_index++  )
+	{	
+		if (fat_register_device(stor_dev, partition_index) == 0)
+		{
+			partition_available = 1 ;	
+			//		stor_dev->dev = partition_index ;
+			printf ("MMC %d:%d is availble for fatls\n", index, partition_index);
+			break;
+		}
+		else
+		{	
+			printf ("Unable to use MMC %d:%d for fatls\n", index, partition_index);
+		}	
+	}
+
+	if(partition_available == 0)
+		return -1 ;
+
+	if (file_fat_detectfs() != 0)
+	{
+		printf ("file_fat_detectfs failed\n");
+		return -1;
+	}
+
+	return 0;
+}
+
+int FatLoadUsb(const char* apFileName, unsigned char* aDestinationAddress, unsigned int aSize, unsigned int * apDataRead)
+{
+	unsigned int sz = file_fat_read(apFileName, (void*) aDestinationAddress, aSize);
+	if (sz == 0xFFFFFFFF) 
+	{
+		debug ("file %s not found\n", apFileName);
+		return -1;
+	}
+	debug_update("Image Size is %d\n", sz);
+	* apDataRead = sz ;
+	return 0;
+}
+
+UInt32 GetUInt32(UInt8* pBuffer)
+{
+	return (UInt32) ( ( * (pBuffer+0) << 0 ) | ( * (pBuffer+1) << 8 ) | ( * (pBuffer+2) << 16 ) | ( * (pBuffer+3) << 24 )  ); 
+}
+
+int ProgramFlash( 	const char* apMtdId, const char* apPartitionName ,
+		UInt32 aOffset,	UInt8* apBuffer, 
+		UInt32 aLength , cnc_ImageType aImageType,
+		UInt32 aPartitionSize )
+{
+	int Status=-1;	
+	image_header_t* hdr = (image_header_t *)apBuffer;
+	//UInt32 addr,off,nbytes;
+	if ( 0 == strcmp ( apMtdId , "cnc-nand" ) )
+	{	
+		printf( "Programming NAND flash MTD_ID=%s PartitionName=%s FlashStartAddress=%08x Length=%d (0x%08x) ImageType=%s\n",
+				apMtdId,
+				apPartitionName , 
+				aOffset ,
+				aLength ,
+				aLength ,ImageTypeByName [aImageType] );
+
+		//Irrespective of type of partition always perform nand erase (don't use erase.spread)				
+		Status = cnc_NandErase( aOffset, aPartitionSize, 0);
+		if (0 != Status ) return Status;				
+
+		if ( aImageType == JFFS2)
+		{
+			printf("Removing Header\n");
+			apBuffer = (UInt8 *)((UInt8 *)hdr + sizeof(*hdr));
+			aLength = aLength - sizeof(*hdr) ;
+			printf("After removing header - %08x %08x\n", (UInt32) apBuffer , aLength);
+			//printf("For JFFS2 erasing complete MTD region, changeing size for erase from %x to %x, (erasing without spread)", aLength, aPartitionSize);
+			//Status = cnc_NandErase( aOffset, aPartitionSize, 0);
+		}
+		else
+		{
+			//Status = cnc_NandErase( aOffset, aLength, 1);
+		}
+		Status = cnc_NandWrite( (UInt32) apBuffer , aOffset, aLength, aImageType );
+		if ( 0 != Status ) return Status;	
+	}
+	else if ( 0 == strcmp ( apMtdId , "emmc" ) )
+	{	
+		printf( "Programming eMMC flash MTD_ID=%s PartitionName=%s FlashStartAddress=%08x Length=%d (0x%08x) ImageType=%s\n",
+				apMtdId,
+				apPartitionName , 
+				aOffset ,
+				aLength ,
+				aLength ,ImageTypeByName [aImageType] );
+#if 0
+		Status = cnc_EMMCErase( aOffset, aPartitionSize);
+		if (0 != Status ) return Status;				
+#endif
+		if ( aImageType == JFFS2)
+		{
+			printf("Removing Header\n");
+			apBuffer = (UInt8 *)((UInt8 *)hdr + sizeof(*hdr));
+			aLength = aLength - sizeof(*hdr) ;
+			printf("After removing header - %08x %08x\n", (UInt32) apBuffer , aLength);
+			//printf("For JFFS2 erasing complete MTD region, changeing size for erase from %x to %x, (erasing without spread)", aLength, aPartitionSize);
+			//Status = cnc_NandErase( aOffset, aPartitionSize, 0);
+		}
+		else
+		{
+			//Status = cnc_NandErase( aOffset, aLength, 1);
+		}
+#ifndef MMC_WRITE_VERIFY
+		Status = cnc_EMMCWrite( (UInt32) apBuffer , aOffset, aLength, aImageType );
+		if ( 0 != Status ) {
+			printf("ERROR: cnc_EMMCWrite\n");
+			return Status;
+		}
+#else
+		while(Status == -1){
+			Status = cnc_EMMCWrite( (UInt32) apBuffer , aOffset, aLength, aImageType );
+			if ( 0 != Status ) {
+				printf("ERROR: cnc_EMMCWrite\n");
+				return Status;
+			}
+			Status = cnc_EMMCVerify2((UInt32) apBuffer, aOffset, aLength);
+			if ( 0 == Status)
+			{
+				printf("%seMMC is verified successfully\n%s", ColorGreen, ColorNormal);
+			}
+			else
+			{
+				printf("%sERROR:Fail to verify eMMC, please check your hardware\n%s", ColorRed, ColorNormal);
+			}
+		}
+#endif
+	}	
+	else if ( 0 == strcmp ( apMtdId , SPI_TOKEN ) )
+	{
+		//SPI flash write
+		printf( "Programming SPI flash MTD_ID=%s PartitionName=%s FlashStartAddress=%08x Length=%d (0x%08x)\n",
+				apMtdId,
+				apPartitionName , 
+				aOffset ,
+				aLength ,
+				aLength);
+		Status = cnc_SpiErase( aOffset, aLength);
+		Status = cnc_SpiWrite( (UInt32) apBuffer , aOffset, aLength);
+	}
+	else if ( 0 == strcmp ( apMtdId , "cnc-nor" ) )
+	{
+		//SPI flash write
+		printf( "Programming SPI flash MTD_ID=%s PartitionName=%s FlashStartAddress=%08x Length=%d (0x%08x)\n",
+				apMtdId,
+				apPartitionName , 
+				aOffset ,
+				aLength ,
+				aLength);
+		Status = cnc_NorErase( aOffset, aLength);
+		Status = cnc_NorWrite( (UInt32) apBuffer , aOffset, aLength);
+	}
+	else
+	{
+		printf("ERROR: Unsupported MTD_ID %s\n, Aborting...\n" , apMtdId );
+	}
+
+	return Status;
+}
+void PrintLongAsciiString(const char* apBuf)
+{
+	while ( *(apBuf) != '\0')
+	{
+		printf("%c", *(apBuf));
+		apBuf++;
+	}
+	printf("\n");
+}
+
+int CompareCurrentBootArgsMtdPartsWithNewOne(const char* apCurrentBootArgs, const char* apNewBootArgs)
+{
+	int Status=0;
+	const char* p1 ;
+	const char* p2 ;
+	int i,j;
+	//printf("Comparing bootargs...\n");
+	p1 = strstr(apCurrentBootArgs, "mtdparts=");
+	if (NULL != p1 )
+	{
+		p1 = p1 + strlen("mtdparts=");
+		p2 = strstr(apNewBootArgs, "mtdparts=");
+		if (NULL != p2 )
+		{
+			p2 = p2 + strlen("mtdparts=");
+			i=0;j=0;
+
+			while(
+					(*(p1+i) != '\0') && (*(p1+i) != ' ') &&
+					(*(p2+j) != '\0') && (*(p2+j) != ' ') 
+				 )
+			{		
+				if ( *(p1+i) == *(p2+j) )
+				{
+					i++;
+					j++;
+				}
+				else
+				{
+					Status = -1;
+					break;
+				}
+				//printf("%d %d %c %c\n", i,j, *(p1+i) , *(p2+j) );
+			}
+		}
+	}
+
+	if ( Status != 0 )
+	{
+		printf("%s\n", ColorYellow);
+		printf("WARNING: bootargs differ...\nrunning system has bootargs=" );
+		PrintLongAsciiString (apCurrentBootArgs);
+		printf("while supplied in image, bootargs=");
+		PrintLongAsciiString(apNewBootArgs);
+		printf("%s\n", ColorNormal);
+	}
+	else
+	{
+		printf(" %sPASS\n%s",  ColorGreen , ColorNormal);
+	}
+
+	Status = 0; // force Status = 0. We don't care if bootargs changes or not durning update image.
+	return Status;
+}
+
+int VerifyImageCrc32(Header1_t * apHeader1, UInt8* pBuffer, UInt32 aLength, int aVerifyImageCrcAlso)
+{
+	int Status = -1;	
+	int i;	
+	int j;
+	char* p1 ;
+	int pos;
+	int cnt;
+	char TempBuf[512];        
+
+	UInt32 ComputedCrc32;
+	UInt32 Crc32InImage;
+
+	debug_update("Signature            = %08X\n", apHeader1->mSignature);
+	debug_update("File format version  = %08X\n", apHeader1->mFileFormatVersionNo);
+	debug_update("Vendor ID            = %08X\n", apHeader1->mVendorId);
+	debug_update("Product ID           = %08X\n", apHeader1->mProductId);
+	debug_update("BootCmd              = %s\n",   apHeader1->mBootCmd  );
+	debug_update("BootArgs             = " );  PrintLongAsciiString(apHeader1->mBootArgs );
+	debug_update("NVRAM\n");
+
+	p1 = apHeader1->mNvRamParamText;
+	pos=0;
+	cnt=0;
+	while (1){
+		cnt =  *( (int*)(p1 + pos) );
+		if (cnt == 0 ){
+			break;
+		}
+		pos=pos+sizeof(int);           
+		memcpy(TempBuf,  p1+pos, cnt);
+		TempBuf[cnt]='\0';
+		pos = pos + cnt;
+		debug_update("%s\n", TempBuf);            
+	}
+
+	debug_update("No.of Image Packaged = %d\n",   apHeader1->mNoOfValidParition);
+	debug_update("CRC                  = %08X\n", apHeader1->mHeaderCrc);    
+	ComputedCrc32 = crc32(0, (void*) apHeader1 , (UInt32) ( (UInt32) & apHeader1->mHeaderCrc - (UInt32) apHeader1 ) ) ;
+	if ( ComputedCrc32 != apHeader1->mHeaderCrc ){
+		debug_update("ERROR: CRC error1\n");
+		return Status;
+	}
+
+	debug_update("RSA Header Signature\n");
+	for(i=0;i<16;i++){
+		for(j=0;j<16;j++){
+			debug_update("%02x ", (UInt8) apHeader1->mRsaSignature[ (i*16) + j ] );
+		}
+		debug_update("\n");
+	}
+
+	for(i=0;i< apHeader1->mNoOfValidParition;i++){
+		debug_update("Valid                    = %d\n", apHeader1->mImageList[i].mValid );
+		debug_update("MtdId                    = %s\n", apHeader1->mImageList[i].mMtdId );
+		debug_update("PartitionName            = %s \n", apHeader1->mImageList[i].mPartitionName );
+		debug_update("VersionNo                = %s\n", apHeader1->mImageList[i].mVersionNo);
+		debug_update("ExtraInfo                = %08X\n", apHeader1->mImageList[i].mExtraInfo);	
+		debug_update("  Image is               = %s\n", (0 == (apHeader1->mImageList[i].mExtraInfo & (1<<0)) ) ? "encrypted" : "unencrypted" );				//d0 - 0 = encrypted (default)   , 1 = unencrypted
+		debug_update("  Image goes to          = %s\n", (0 == (apHeader1->mImageList[i].mExtraInfo & (1<<1)) ) ? "NAND" : "SPI" );								//d1 - 0 = nand (default)        , 1 = spi
+		debug_update("  Image wiriting mode    = %s\n", (0 == (apHeader1->mImageList[i].mExtraInfo & (1<<2)) ) ? "Erase & Write" : "Preserved Old Content" );	//d2 - 0 = erase & write(default), 1 = preserved old content
+		debug_update("  Image Type             = %s\n", ImageTypeByName[ (apHeader1->mImageList[i].mExtraInfo >> 3) & 3 ] );			
+		debug_update("ImageLength              = %d\n" ,apHeader1->mImageList[i].mImageLength );
+		debug_update("ImagePositionInFile      = %08X\n" , apHeader1->mImageList[i].mImagePositionInFile );
+		debug_update("PartitionSizeInFlash     = %08X\n", apHeader1->mImageList[i].mPartitionSizeInFlash ); 
+		debug_update("PartitionPositionInFlash = %08X\n", apHeader1->mImageList[i].mPartitionPositionInFlash);
+		debug_update("CRC32 %08x %08x\n", (UInt32)( pBuffer + apHeader1->mImageList[i].mImagePositionInFile) , apHeader1->mImageList[i].mImageLength );
+
+		if ( 1 == aVerifyImageCrcAlso){
+			if(!dcache_status()){
+				dcache_enable();
+			}
+			ComputedCrc32 = crc32(0, pBuffer + apHeader1->mImageList[i].mImagePositionInFile, apHeader1->mImageList[i].mImageLength );
+			dcache_disable();
+			Crc32InImage = * ( (UInt32*)( pBuffer + apHeader1->mImageList[i].mImagePositionInFile + apHeader1->mImageList[i].mImageLength) );
+			if ( ComputedCrc32 != Crc32InImage ){
+				printf("ERROR: CRC error3\n");
+				return Status;
+			}
+		}
+	}
+	Status=0;
+	return Status;	
+}
+
+int ProgramNvRamParameter(Header1_t* apHeader1)
+{
+	char TempBuf[512]={0};
+	int Status;
+	//First unset 
+	setenv("kernel_load_addr", ""); 
+	setenv("rootfs_load_addr", "");
+	setenv("blob_load_addr", "");	
+	//SetCustomerName
+	memset(TempBuf, 0, sizeof(TempBuf) );
+	strncpy(TempBuf, apHeader1->mCustomerName, strlen(apHeader1->mCustomerName) );
+	Status = setenv( "CUSTOMER_NAME" , TempBuf);
+	if (Status != 0 )
+	{
+		return -1;
+	}
+	//Now program new bootargs and bootcmd
+	memset(TempBuf, 0, sizeof(TempBuf) );
+	strncpy(TempBuf, apHeader1->mBootCmd, strlen(apHeader1->mBootCmd)  ); //skip ""
+	Status = setenv( "bootcmd" , TempBuf);
+	if (Status != 0 )
+	{
+		return -1;
+	}
+	memset(TempBuf, 0, sizeof(TempBuf));
+	strncpy(TempBuf, apHeader1->mBootArgs, strlen(apHeader1->mBootArgs) ); //skip ""
+	Status = setenv( "bootargs" , TempBuf);
+	if (Status != 0 )
+	{
+		return -1;
+	}
+	Status = saveenv();
+	if (Status != 0 )
+	{
+		return -1;
+	}
+	return 0;
+}
+
+int Update_UpdateObjectFromHeader1(UpdateCommandObject_t  * apUpdateObject, Header1_t * apHeader1)
+{
+	int i = 0;
+	int j = 0;
+
+	int found = -1;
+	for (i = 0; i < apUpdateObject->mNoOfValidParition; i++)
+	{
+		found = -1;
+		for (j = 0; j < apHeader1->mNoOfValidParition; j++)
+		{
+			if (0 == strcmp(apUpdateObject->mUpdateObjectList[i].mPartitionName, apHeader1->mImageList[j].mPartitionName))
+			{
+				strncpy(apUpdateObject->mUpdateObjectList[i].mMtdId, apHeader1->mImageList[j].mMtdId, sizeof(apUpdateObject->mUpdateObjectList[i].mMtdId));
+				strncpy(apUpdateObject->mUpdateObjectList[i].mPartitionName, apHeader1->mImageList[j].mPartitionName, sizeof(apUpdateObject->mUpdateObjectList[i].mPartitionName));
+				apUpdateObject->mUpdateObjectList[i].mPartitionPositionInFlash = apHeader1->mImageList[j].mPartitionPositionInFlash;
+				apUpdateObject->mUpdateObjectList[i].mImagePositionInFile = apHeader1->mImageList[j].mImagePositionInFile;
+				apUpdateObject->mUpdateObjectList[i].mImageLength = apHeader1->mImageList[j].mImageLength;
+				apUpdateObject->mUpdateObjectList[i].mExtraInfo = apHeader1->mImageList[j].mExtraInfo;
+				apUpdateObject->mUpdateObjectList[i].mPartitionSizeInFlash = apHeader1->mImageList[j].mPartitionSizeInFlash;
+				found = 0;
+				break;
+			}
+		}
+
+		if (-1 == found)
+		{
+			printf("%sERROR: Invalid patition name \"%s\"specfied to upgrade%s\n", ColorRed, apUpdateObject->mUpdateObjectList[i].mPartitionName, ColorNormal);
+			return -1;
+		}
+	}	
+	return 0;
+}
+
+extern int do_csupgrade_logo(void);
+int do_updatex (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	char CmdBuf[512]={0};
+	char TempBuf[512]={0};
+	Header1_t mHeader1;
+	UpdateCommandObject_t  UpdateObject;
+	UpdateCommandParameterListObject_t  ParameterObject;
+	ImagePartitionList_t ImagePartitionList;
+	char* event_ptr, *bootsrc;    
+
+	int i;
+	int Status=-1;
+	char* p1;
+	int MtdPartsAreMatchingOktoProgram=0;
+	unsigned char *pStorageBuffer = (unsigned char *)DDR_LOAD_ADDRESS;
+	UInt32 mDataRead=0;	
+	char* xp1;    
+	int usb_read_try_time = 5;
+
+	for(i=0;i<argc;i++){
+		strncat(CmdBuf, argv[i], sizeof(CmdBuf)-strlen(CmdBuf) );
+		strncat(CmdBuf, " ", sizeof(CmdBuf)-strlen(CmdBuf) );
+	}
+	p1 = CmdBuf;
+
+	memset(&UpdateObject , 0, sizeof(UpdateObject) );
+	memset(&ParameterObject , 0, sizeof(ParameterObject) );
+
+	bootsrc = getenv("updatesrc");
+	if(bootsrc != NULL){
+		UpdateObject.mUsb = simple_strtoul(bootsrc, NULL, 10);
+	}else{
+		UpdateObject.mUsb = CONFIG_CMD_UPDATE_SOURCE;
+	}
+
+	Status = ParseUpdateCommand(p1, & ParameterObject,  & UpdateObject);
+	if ( 0 != Status  ){
+		printf("%sERROR: while parsing update command error occured%s\n", ColorRed, ColorNormal);
+	}
+	if(-1 != gpio_num_for_blink)
+		register_and_enable_wd_timer_irq(usec_to_tick(rate_in_ms*1000));
+
+	event_ptr = getenv("pre_update_event");
+	if (NULL != event_ptr ){
+		run_command(event_ptr,0);
+	}
+
+#if 0	
+	printf("Usb=%d\n",UpdateObject.mUsb); 
+	printf("Force=%d\n",UpdateObject.mForce); 
+	if ( UpdateObject.mUsb == 0 )
+	{
+		printf("IpAddress=%s\n", UpdateObject.mIpAddress);
+	}    
+	printf("FileName=%s\n",UpdateObject.mFileName);
+	for (i=0;i<UpdateObject.mNoOfValidParition;i++)
+	{
+		printf("%s\n", UpdateObject.mPartitionNameList[i]);
+	}
+#endif
+
+	if (1 == UpdateObject.mUsb )
+	{
+		printf("Starting USB...\n");
+		Status = UsbStart();
+		if (-1 == Status)
+		{			
+			goto boot_cmd_error_file_usb;
+		}
+	}
+	if (2 == UpdateObject.mUsb || 3 == UpdateObject.mUsb)
+	{
+		printf("Scanning MMC...\n");
+		Status = MMCStart(UpdateObject.mUsb - 2);
+		if (-1 == Status)
+		{			
+			goto boot_cmd_error_file_usb;
+		}
+	}
+
+	if (UpdateObject.mUsb == 1 || UpdateObject.mUsb == 2 || UpdateObject.mUsb == 3)
+	{
+		Status = FatLoadUsb(UpdateObject.mFileName, pStorageBuffer, sizeof(mHeader1) , &mDataRead ); //First load header only
+		if( (-1 == Status) || ( sizeof(mHeader1) != mDataRead ) )
+		{
+			printf("%sCould not found %s file\n%s" ,ColorYellow, UpdateObject.mFileName, ColorNormal);
+			//May be cnc83xxU.bin might be present - try that one.
+			strncpy(UpdateObject.mFileName, DEFAULT_CNC83XXU_FILE_NAME , sizeof (UpdateObject.mFileName));
+			printf("%strying to load %s file\n%s" ,ColorYellow, UpdateObject.mFileName, ColorNormal);
+			Status = FatLoadUsb(UpdateObject.mFileName, pStorageBuffer, sizeof(mHeader1) , &mDataRead ); //First load header only
+			if( (-1 == Status) || ( sizeof(mHeader1) != mDataRead ) )
+			{
+				//both image are failed.
+				goto boot_cmd_error_file_usb;
+			}
+		}
+
+		do_csupgrade_logo();
+#if 1		
+		//Validate header
+		memcpy( & mHeader1 , pStorageBuffer , sizeof(mHeader1) );	
+		printf("Verifying image header...");	
+		Status = VerifyImageCrc32( & mHeader1 , pStorageBuffer, mDataRead,0);//verify header only(do not verify image crc)
+		if (-1 == Status)
+		{
+			printf(" FAIL\n");
+			goto  boot_cmd_error_crc;
+		}
+		printf(" %sPASS\n%s",  ColorGreen , ColorNormal);
+#endif		
+boot_cmd_read_usb_image:
+		//Now load complete image
+		printf("Loading complete image\n");
+		Status = FatLoadUsb(UpdateObject.mFileName, pStorageBuffer, 0, &mDataRead ); 
+		if (-1 == Status)
+		{
+			goto boot_cmd_error_file_usb;
+		}
+		printf("\nChecking image integrity ...");
+		Status = VerifyImageCrc32( & mHeader1 , pStorageBuffer, mDataRead,1);//now verify image crc also.
+		if (-1 == Status)
+		{
+			printf(" %sFAIL%s\n", ColorRed, ColorNormal);
+			if(usb_read_try_time){
+				usb_read_try_time --;
+				printf("try to ");
+				goto boot_cmd_read_usb_image;
+			}
+			else{
+				printf("Already try 5 times, still got error, exit!\n");
+				goto  boot_cmd_error_crc;
+			}
+		}
+		printf(" %sPASS%s\n", ColorGreen, ColorNormal);
+
+	}
+	else
+	{
+		printf("updating from tftp\n");
+		int size= 0 ;
+		load_addr = DDR_LOAD_ADDRESS;
+		copy_filename (BootFile,  UpdateObject.mFileName , sizeof(BootFile));
+		if ((size = NetLoop(TFTP)) < 0) {
+			show_boot_progress (-81);
+			return 1;
+		}
+
+		memcpy( & mHeader1 , pStorageBuffer , sizeof(mHeader1) );
+		//verify header only.
+		Status = VerifyImageCrc32( & mHeader1 , pStorageBuffer, mDataRead,0);
+		if (-1 == Status)
+		{
+			goto  boot_cmd_error_crc;
+		}
+
+		printf("\nChecking image integrity ...");
+		Status = VerifyImageCrc32( & mHeader1 , pStorageBuffer, mDataRead,1);//now verify image crc also.
+		if (-1 == Status)
+		{
+			printf(" FAIL\n");
+			goto  boot_cmd_error_crc;
+		}
+		printf(" OK\n");	
+	}
+
+
+	memcpy( & mHeader1 , pStorageBuffer , sizeof(mHeader1) );
+
+	Status = -1;
+	xp1 = getenv("bootargs");
+	if (xp1 != NULL )
+	{
+		Status = CompareCurrentBootArgsMtdPartsWithNewOne(xp1 ,  mHeader1.mBootArgs );
+	}	
+
+	if (Status == 0)
+	{
+		//mtdparts are matching
+		MtdPartsAreMatchingOktoProgram=1;				
+	}
+	else
+	{
+		if( 1 == UpdateObject.mForce) // "force"
+		{
+			if ( 0 == ProgramNvRamParameter( & mHeader1 ) )
+			{
+				MtdPartsAreMatchingOktoProgram=1;
+			}
+		}
+		else
+		{
+			MtdPartsAreMatchingOktoProgram = 0;
+		}
+	}
+
+	//---------------------------------------
+	Status = GenerateImagePartitionListFromBootArgs(mHeader1.mBootArgs, & ImagePartitionList);
+	if (Status == -1)
+	{
+		puts(ColorRed);printf("ERROR: error occured while parsing bootargs, please contact vendor\n");puts(ColorNormal);
+		return -1;
+	}
+	//---------------------------------------
+	if (0 == MtdPartsAreMatchingOktoProgram )
+	{
+		puts(ColorYellow);
+		printf("MTD parition information was not matching with existing image\n");
+		printf("Before porgramming image, we want to make sure, in supplied image file %s all parition are defined\n" , UpdateObject.mFileName);
+		printf("In such cases, partial upgrade is not allowed. \n");
+		printf("OR\nYou can try \nupdate force usb://cnc83xx.bin\n");
+
+		puts(ColorNormal);
+		Status = VerifyAllPartitionPresentInImage( & mHeader1 , & ImagePartitionList);
+		if ( UpdateObject.mForce ==1 )
+		{
+			//goto force_continue;
+		}
+		else if (-1 == Status)
+		{
+			puts(ColorRed);
+			printf("ERROR: please contact vendor and try to get image which has all paritions defined\n");
+			printf("       aborting firmware upgrade\n");
+			puts(ColorNormal);
+			return -1;
+		}
+	}
+	//--------------------------------------------------------------------------------
+	Status = Update_UpdateObjectFromHeader1(& UpdateObject, & mHeader1);
+	if (-1 == Status)
+	{
+		return Status;
+	}
+	//--------------------------------------------------------------------------------
+	if ( 0 != UpdateObject.mNoOfValidParition )
+	{
+		i=0;
+		for( i = 0 ; i < UpdateObject.mNoOfValidParition ; i++ )
+		{
+			Status = ProgramFlash(  UpdateObject.mUpdateObjectList[i].mMtdId,
+					UpdateObject.mUpdateObjectList[i].mPartitionName,
+					UpdateObject.mUpdateObjectList[i].mPartitionPositionInFlash,
+					pStorageBuffer + UpdateObject.mUpdateObjectList[i].mImagePositionInFile,
+					UpdateObject.mUpdateObjectList[i].mImageLength,
+					(cnc_ImageType)( (UpdateObject.mUpdateObjectList[i].mExtraInfo >> 3) & 3) ,
+					UpdateObject.mUpdateObjectList[i].mPartitionSizeInFlash
+					);
+		}
+	}
+	else
+	{
+		i=0;
+		for(i=0;i< mHeader1.mNoOfValidParition;i++)
+		{
+			Status = ProgramFlash( 	mHeader1.mImageList[i].mMtdId, 
+					mHeader1.mImageList[i].mPartitionName,
+					mHeader1.mImageList[i].mPartitionPositionInFlash,
+					pStorageBuffer + mHeader1.mImageList[i].mImagePositionInFile ,
+					mHeader1.mImageList[i].mImageLength ,
+					(cnc_ImageType)( (mHeader1.mImageList[i].mExtraInfo >> 3) & 3),
+					mHeader1.mImageList[i].mPartitionSizeInFlash
+					);
+			if (-1 == Status )
+			{
+				goto boot_cmd_error_nand_programming;
+			}		
+		}
+	}
+
+	//First unset 
+	setenv("kernel_load_addr", ""); 
+	setenv("rootfs_load_addr", "");
+	setenv("blob_load_addr", "");	
+	//SetCustomerName
+	memset(TempBuf, 0, sizeof(TempBuf) );
+	strncpy(TempBuf, mHeader1.mCustomerName, strlen(mHeader1.mCustomerName) );
+	Status = setenv( "CUSTOMER_NAME" , TempBuf);
+	if (Status != 0 )
+	{
+		goto boot_cmd_error_write2nvram_fail;
+	}
+	//Now program new bootargs and bootcmd
+	memset(TempBuf, 0, sizeof(TempBuf) );
+	strncpy(TempBuf, mHeader1.mBootCmd, strlen(mHeader1.mBootCmd) ); //skip ""
+	Status = setenv( "bootcmd" , TempBuf);
+	if (Status != 0 )
+	{
+		goto boot_cmd_error_write2nvram_fail;
+	}
+	memset(TempBuf, 0, sizeof(TempBuf));
+	strncpy(TempBuf, mHeader1.mBootArgs, strlen(mHeader1.mBootArgs) ); //skip ""
+	Status = setenv( "bootargs" , TempBuf);
+	if (Status != 0 )
+	{
+		goto boot_cmd_error_write2nvram_fail;
+	}
+	Status = saveenv();
+	if (Status != 0 )
+	{
+		goto boot_cmd_error_write2nvram_fail;
+	}
+#if (CONFIG_TARGET_NAME == CNW83XX_OTT_EMMC) || (CONFIG_TARGET_NAME == CNW83XX_SONY_VEDETT)
+	{
+		cnc_EMMCRescan();
+		cnc_CreatGPTPartitionTable(&ImagePartitionList);
+	}
+#endif
+	goto boot_cmd_ok;   	
+
+
+boot_cmd_error_nand_programming:
+	Status = -1;
+	printf("%sERROR: Nand programming failed for partition %s %s\n%s", 
+			ColorRed, mHeader1.mImageList[i].mMtdId, mHeader1.mImageList[i].mPartitionName, ColorNormal );
+	goto boot_cmd_exit;
+
+boot_cmd_error_crc:
+	Status = -1;
+	printf("%sERROR: Image file %s is corrupted\n%s" ,ColorRed, UpdateObject.mFileName, ColorNormal);
+	goto boot_cmd_exit;
+
+boot_cmd_error_file_usb:
+	Status = -1;
+	printf("%sERROR: Unable to open file %s\n%s" ,ColorRed, UpdateObject.mFileName, ColorNormal);
+	goto boot_cmd_exit;
+
+
+boot_cmd_error_write2nvram_fail:
+	Status = -1;
+	printf("%sERROR: Unable to update nvram bootargs / bootcmd parameters%s" , ColorRed , ColorNormal );
+	goto boot_cmd_exit;
+
+boot_cmd_ok:
+	Status = 0;
+	printf("%s%s is updated successfully\n%s", ColorGreen, UpdateObject.mFileName , ColorNormal);
+	printf("%sPlease reset your sytem\n%s" , ColorGreen, ColorNormal);
+
+	event_ptr = getenv("post_update_event");
+	if (NULL != event_ptr )
+	{
+		run_command(event_ptr,0);
+	}
+
+boot_cmd_exit:
+	if(-1 != gpio_num_for_blink)
+		disable_and_unregister_wd_timer_irq();
+
+	return Status;
+}
+
+int test_emmc1 (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	//	char mBootArgs[512];
+	ImagePartitionList_t ImagePartitionList;
+	int Status = 1;
+
+	cnc_EMMCRescan();
+	Status = GenerateImagePartitionListFromBootArgs(getenv("bootargs"), & ImagePartitionList);
+	if (Status == -1)
+	{
+		puts(ColorRed);printf("ERROR: error occured while parsing bootargs, please contact vendor\n");puts(ColorNormal);
+		return -1;
+	}
+	cnc_CreatGPTPartitionTable(&ImagePartitionList);
+	return 0;
+}
+//-----------------------------------------------------------------------------------------------------------------------------------------------------
+
+U_BOOT_CMD(
+		update, 10, 0, do_updatex,
+		"update various partitions in flash from a file\n",
+		"[CSV_LIST_OF_MTD_PARTITION_NAMES] [force] [filename-url]\n"
+		"  [CSV_LIST_OF_MTD_PARTITION_NAMES] - from mtd-parts in bootargs (splash,uboot,kernel,jffs2,...)\n"
+		"  [force] - ignore mtd partition information and version checks\n"
+		"  [filename-url] - usb://filename, tftp://filename. If not included, use USB cnc83xx.bin, then cnc83xxU.bin.\n"
+		"  [blink] <gpio_num> <rate_in_ms>\n"
+		);
+U_BOOT_CMD(
+		test_emmc, 10, 0, test_emmc1,
+		"update various partitions in flash from a file\n",
+		"[CSV_LIST_OF_MTD_PARTITION_NAMES] [force] [filename-url]\n"
+		"  [CSV_LIST_OF_MTD_PARTITION_NAMES] - from mtd-parts in bootargs (splash,uboot,kernel,jffs2,...)\n"
+		"  [force] - ignore mtd partition information and version checks\n"
+		"  [filename-url] - usb://filename, tftp://filename. If not included, use USB cnc83xx.bin, then cnc83xxU.bin.\n"
+		"  [blink] <gpio_num> <rate_in_ms>\n"
+		);
+#endif
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_update_misc.c u-boot-2011.06/common/cmd_update_misc.c
